;##########################;
;# mIRC Script Obfuscator #;
;# Version 1.1            #;
;# By IceShaman           #;
;##########################;

on *:load: {
  if ($version < 6.17) { var %x = $input(mIRC 6.17 or higher required,ou,Error) | unload -rs $+(",$script,") } 
}

alias mso { 
  if ($dialog(MSO)) { dialog -v MSO | return }
  dialog -dm MSO MSO
}

dialog MSO {
  title "mIRC Script Obfuscator v1.1"
  size -1 -1 191 129
  option dbu
  tab "Files", 6, 1 1 188 125
  tab "Settings", 3
  tab "Status", 7
  box "Global Options (affects all files - overruled by per file options)", 17, 3 18 182 31, tab 3
  box "Options", 40, 4 92 182 29, tab 6
  list 8, 4 20 143 72, tab 6 size
  button "Add", 9, 149 20 37 12, tab 6
  button "Del", 10, 149 34 37 12, tab 6 disable
  button "Directory", 11, 149 49 37 12, tab 6
  check "Obfuscate Variables", 12, 8 101 69 9, tab 6 disable
  check "Obfuscate custom aliases & identifiers", 13, 82 101 100 9, tab 6 disable
  button "Clear", 31, 149 64 37 12, tab 6 disable
  button "Obfuscate", 18, 149 79 37 12, tab 6 disable
  list 38, 138 2 51 10, tab 6 hide size
  list 32, 87 2 51 10, tab 6 hide size
  check "Obfuscate binvars", 43, 8 111 69 8, tab 6 disable
  check "Strip comments", 44, 82 111 100 8, tab 6 disable
  list 15, 5 19 180 107, tab 7
  check "Obfuscate Variables", 19, 7 26 69 9, tab 3
  check "Obfuscate binvars", 21, 7 36 69 8, tab 3
  check "Strip comments", 22, 81 35 100 8, tab 3
  check "Obfuscate custom aliases + identifiers", 24, 81 26 100 9, tab 3
  box "Hash Settings", 25, 3 52 182 43, tab 3
  edit "O0", 26, 39 60 44 10, tab 3
  text "Charset:", 27, 7 60 31 8, tab 3
  text "Min Length:", 28, 7 71 31 8, tab 3
  edit "8", 29, 39 72 44 10, tab 3
  text "Max Length:", 30, 7 83 31 8, tab 3
  edit "10", 34, 39 82 44 10, tab 3
  box "Output", 35, 3 97 182 21, tab 3
  text "Subdirectory:", 36, 7 106 34 8, tab 3
  edit "Obfuscate\", 37, 45 105 63 10, tab 3
  edit "", 42, 138 1 50 10, tab 3 hide
  menu "File", 1
  item "Load", 2, 1
  item "Save", 4, 1
  item "Exit", 5, 1
  menu "Help", 33
  item "About", 16, 33
  item "Readme", 39, 33
}

on *:dialog:MSO:init:*: { 
  freetables all 
  did -c $dname 19,21,22,24
}

on *:dialog:MSO:menu:*: {
  ;load settings
  if ($did == 2) {
    var %file = " $+ $$sfile(*.*,Open,Open) $+ ", %fdone = 0
    did -o $dname 42 1 %file
    if ($ini(%file,0)) { did -r $dname 8 }
    while (%fdone < $ini(%file,0)) {
      inc %fdone
      if ($left($ini(%file,%fdone),5) == file_) { 
        var %listbox_path = $replace($right($ini(%file,%fdone),-5),$chr(63),$chr(32)), %listbox_file = $right(%listbox_path,$calc($len(%listbox_path) - $pos(%listbox_path,$chr(92),$pos(%listbox_path,$chr(92),0))))  
        did -a $dname 8 $iif($readini(%file,n,$ini(%file,%fdone),subdir),$ifmatch $+ %listbox_file,%listbox_file)  
        var %setline = $iif($readini(%file,n,$ini(%file,%fdone),obfvars) == true,1,0)
        var %setline = $iif($readini(%file,n,$ini(%file,%fdone),obfbinvars) == true,%setline 1,%setline 0)
        var %setline = $iif($readini(%file,n,$ini(%file,%fdone),obfalias) == true,%setline 1,%setline 0)
        var %setline = $iif($readini(%file,n,$ini(%file,%fdone),strip_comments) == true,%setline 1,%setline 0)
        did -a $dname 32 %setline
        did -a $dname 38 %listbox_path        
      }
    } 
    if ($readini(%file,n,global,obfvars) == true) { did -c $dname 19 }
    if ($readini(%file,n,global,obfbinvars) == true) { did -c $dname 21 }
    if ($readini(%file,n,global,obfalias) == true) { did -c $dname 24 }
    if ($readini(%file,n,global,strip_comments) == true) { did -c $dname 22 }
    if ($readini(%file,n,global,charset)) { did -o $dname 26 1 $ifmatch }
    if ($readini(%file,n,global,min_length) isnum) { did -o $dname 29 1 $v1 }
    if ($readini(%file,n,global,max_length) isnum) { did -o $dname 34 1 $v1 }
    if ($readini(%file,n,global,subdir)) { did -o $dname 37 1 $ifmatch }
    if ($did($dname,8).lines) { did -e $dname 18,31 }
    var %x = $input(Successfully loaded settings!,ou,Settings)
  }

  ;save settings 
  elseif ($did == 4) {
    var %file = " $+ $$sfile($iif($did($dname,42).text,$ifmatch,obfuscate.ini),Save As,Save) $+ "
    did -o $dname 42 1 %file
    write -c %file
    if ($did($dname,19).state == 1) { writeini -n %file global obfvars true }
    if ($did($dname,21).state == 1) { writeini -n %file global obfbinvars true }
    if ($did($dname,24).state == 1) { writeini -n %file global obfalias true }
    if ($did($dname,22).state == 1) { writeini -n %file global strip_comments true }
    if ($did($dname,26).text) { writeini -n %file global charset $ifmatch }
    if ($did($dname,29).text isnum) { writeini -n %file global min_length $v1 }
    if ($did($dname,34).text isnum) { writeini -n %file global max_length $v1 }
    if ($did($dname,37).text) { 
      var %subdirectory = $did($dname,37).text
      var %subdirectory = $iif($left(%subdirectory,1) == $chr(92),$right(%subdirectory,-1),%subdirectory)
      writeini -n %file global subdir $iif($right(%subdirectory,1) != $chr(92),%subdirectory $+ $chr(92),%subdirectory)
    }
    var %obfu_files = $did($dname,8).lines, %done = 0

    while (%done < %obfu_files) {
      inc %done
      var %obfu_file = $+($replace($did($dname,38,%done).text,$chr(32),$chr(63)),$iif($right($did($dname,8,%done).text,1) == $chr(92),$chr(92)))
      var %setline = $did($dname,32,%done).text, %y = 0, %setstring = obfvars obfbinvars obfalias strip_comments
      writeini -n %file $+(file_,%obfu_file) obfuscate true      
      while (%y < $numtok(%setline,32)) { 
        inc %y
        if ($gettok(%setline,%y,32) == 1) { writeini -n %file $+(file_,%obfu_file) $gettok(%setstring,%y,32) true }
      }
      if ($chr(92) isin $did($dname,8,%done).text) { writeini -n %file $+(file_,%obfu_file) subdir $gettok($did($dname,8,%done).text,1- $+ $calc($numtok($did($dname,8,%done).text,92) - 1),92) $+ \ } 
    }
    var %x = $input(Successfully saved settings!,ou,Settings) $+(file_,%obfu_file)
  }

  ;exit
  elseif ($did == 5) { 
    if ($hget(global_settings,status:started) == true) { 
      if ($?!="Obfuscation is in proccess, are you sure you want to exit?" == $false) { return } 
    }
    dialog -x $dname 
  }

  ;about box
  elseif ($did == 16) { var %x = $input(mIRC Script Obfuscator v1.1 By IceShaman,ou,About) }

  ;load readme file
  elseif ($did == 39) { 
    if ($exists(" $+ $scriptdir\readme.txt $+ ")) { .run " $+ $scriptdir\readme.txt $+ " }
    else { var %x = $input(Cannot locate readme file,ou,Error) }
  }
}

on *:dialog:MSO:sclick:*: {
  ;add files
  if ($did == 9) {
    var %x = $$msfile(*,Files To Add,Select)
    did -b $dname 12,13,43,44
    if ($msfile(0) == -1) { var %x = $input(Too many files selected (try selecting the directory instead),ou,Error) | return }
    elseif ($msfile(0) == 0) { return }
    var %files = $msfile(0), %done = 0
    while (%done < %files) {
      inc %done
      did -a $dname 8 $right($msfile(%done),$calc($len($msfile(%done)) - $pos($msfile(%done),$chr(92),$pos($msfile(%done),$chr(92),0))))
      did -a $dname 38 $msfile(%done)
      did -a $dname 32 0 0 0 0 0
    }
    if ($did($dname,8).lines) { did -e $dname 10,18,31 }
  }

  ;delete files
  elseif ($did == 10) {
    if (!$did($dname,8).sel) { return }
    did -d $dname 8,32,38 $did($dname,8).sel
    if ($did($dname,8).lines == 0) { did -b $dname 10,12,13,18,31,43,44 | did -e $dname 9,11 }
    else { 
      did -e $dname 10,31,12,43,13,44
      did -u $dname 12,13,43,44
      did -c $dname 8 1 
      var %setline = $did($dname,32,1).text
      if ($gettok(%setline,1,32) == 1) { did -c $dname 12 } 
      if ($gettok(%setline,3,32) == 1) { did -c $dname 43 } 
      if ($gettok(%setline,4,32) == 1) { did -c $dname 13 } 
      if ($gettok(%setline,6,32) == 1) { did -c $dname 44 } 
    }
  }  

  ;add directory
  elseif ($did == 11) {
    var %dir = $$sdir(dir,Select A Folder), %extension = mrc, %files = $findfile(%dir,$+(*.,%extension),0), %done = 0
    did -b $dname 12,13,43,44
    while (%done < %files) {
      inc %done
      var %file = $right($findfile(%dir,$+(*.,%extension),%done),- $+ $len(%dir))
      did -a $dname 8 %file
      did -a $dname 38 $findfile(%dir,$+(*.,%extension),%done)
      did -a $dname 32 0 0 0 0 0
    }
    if ($did($dname,8).lines) { did -e $dname 10,18,12,13,31,43,44 }
  }

  ;clear files
  elseif ($did == 31) { did -b $dname 10,12,13,18,31,43,44 | did -r $dname 8,15,32,38 | did -u $dname 12,13,43,44 | did -e $dname 9,11 }

  ;select file
  elseif ($did == 8) {
    did -e $dname 10,31,12,43,13,44
    did -u $dname 12,13,43,44
    var %setline = $did($dname,32,$did($dname,8).sel).text
    if ($gettok(%setline,1,32) == 1) { did -c $dname 12 } 
    if ($gettok(%setline,3,32) == 1) { did -c $dname 43 } 
    if ($gettok(%setline,4,32) == 1) { did -c $dname 13 } 
    if ($gettok(%setline,6,32) == 1) { did -c $dname 44 } 
  }

  ;update settings for files
  elseif ($findtok(12 43 13 44,$did,32)) {
    if (!$did($dname,8).sel) { return }
    var %setnum = $findtok(12 43 13 44,$did,32), %setstring = $did($dname,32,$did($dname,8).sel).text
    did -o $dname 32 $did($dname,8).sel $puttok(%setstring,$iif($did($dname,$did).state == 1,1,0),%setnum,32)
  }

  ;end here if we're not obfuscating
  if ($did != 18) { return }

  if ($did($dname,18).text == Halt) { hadd -m global_settings status:stop true | did -f $dname 7 | did -o $dname 18 1 Obfuscate | return }
  elseif ($hget(global_settings,status:started) == true) { did -o $dname 18 1 Halt | return }

  if (!$did($dname,8).lines) { var %x = $input(No files added,ou,Error) | return }
  did -b $dname 6,8,9,10,11,12,13,18,31,43,44
  did -u $dname 12,13,43,44
  did -r $dname 15
  did -f $dname 7 

  ;check for subdirectory
  if ($did($dname,37).text) {
    var %subdirectory = $did($dname,37).text
    var %subdirectory = $iif($left(%subdirectory,1) == $chr(92),$right(%subdirectory,-1),%subdirectory)
    var %subdirectory = $iif($right(%subdirectory,1) != $chr(92),%subdirectory $+ $chr(92),%subdirectory)
  }
  else { var %subdirectory = Obfuscate\ }

  ;create obfuscate subdirectory
  if (!$isdir($+(",$scriptdir,%subdirectory,"))) { mkdir $+(",$scriptdir,%subdirectory,") }

  var %obfu_files = $did($dname,8).lines, %done = 0, %ticks = $ticks

  hmake global_settings 10
  if ($did($dname,26).text) { hadd -m global_settings hash:charset $ifmatch }
  else { hadd -m global_settings hash:charset O0 }
  if ($did($dname,29).text isnum) { hadd -m global_settings hash:min_length $v1 }
  else { hadd -m global_settings hash:min_length 8 }
  if ($did($dname,34).text isnum) { hadd -m global_settings hash:max_length $v1 }
  else { hadd -m global_settings hash:max_length 10 }
  hadd -m global_settings status:started true

  while (%done < %obfu_files) {
    inc %done
    var %obfu_file = $+($replace($did($dname,38,%done).text,$chr(63),$chr(32)),$iif($right($did($dname,8,%done).text,1) == $chr(92),$chr(92)))
    if (!$exists(%obfu_file)) { echo here | showinfo File not found! $+(",$left($did($dname,8,%done).text,30),") }
    var %x = $regex($did($dname,8,%done).text,/(.*\\)/), %obfu_outdir = $regml(1), %obfu_outfile = $did($dname,8,%done).text, %setline = $did($dname,32,%done).text
    freetables   
    hmake settings 10

    if ($gettok(%setline,1,32) == 1) { hadd -m settings do:aliases true local }
    elseif ($did($dname,24).state == 1) { hadd -m settings do:aliases true local }
    if ($gettok(%setline,2,32) == 1) { hadd -m settings do:variables true | hadd -m settings do:identifiers true }
    elseif ($did($dname,19).state == 1) { hadd -m settings do:variables true | hadd -m settings do:identifiers true }
    if ($gettok(%setline,3,32) == 1) { hadd -m settings do:binvars true }
    elseif ($did($dname,21).state == 1) { hadd -m settings do:binvars true }
    if ($gettok(%setline,4,32) == 1) { hadd -m settings do:comments true }
    elseif ($did($dname,22).state == 1) { hadd -m settings do:comments true }

    hadd -m settings out:dir $+(",$scriptdir,%subdirectory,%obfu_outdir,")
    hadd -m settings out:file $+(",$scriptdir,%subdirectory,%obfu_outfile,")
    did -o $dname 18 1 Halt
    did -e $dname 18
    if (%done > 1) { showinfo }
    if (%obfu_files > 1) { showinfo File %done of $+($v1,:) $+(",$left($did($dname,8,%done).text,30),") }
    obfuscate %obfu_file
  }
  showinfo <DL> Script Obfuscation completed in $round($calc(($ticks - %ticks) / 1000),2) seconds
  did -e $dname 6,8,9,10,11,18,31
  did -o $dname 18 1 Obfuscate
  freetables all
}

alias obfuscate {
  hmake lookup 200
  var %script = $1-, %lines = $lines(%script), %done = 0, %regex = $obfsetup
  showinfo Collecting information...
  while (%done < %lines) {
    inc %done
    dll " $+ $scriptdir $+ WhileFix.dll" WhileFix 
    if ($hget(global_settings,status:stop) == true) || (!$dialog(MSO)) { showinfo <DL> Obfuscation aborted... | freetables all | did -e $dname 6,8,9,10,11,18,31 | halt }
    var %line = $read(%script,n,%done).text
    getstatus collect %lines %done
    if ($left(%line,2) == */) { var %comment }
    elseif (($left(%line,1) == $chr(59)) || ($left(%line,1) == $chr(35)) || (%comment)) { continue }
    elseif ($left(%line,2) == /*) { var %comment = true | continue }
    hadd -m settings temp:line %line
    varsearch %regex $iif(%result == followon,true,false)
    var %result = $result
  }
  showinfo Generating hashes...
  genlookup
  showinfo Writing script...
  writescript %script
  freetables
}

;frees the hash tables
alias freetables {
  if ($hget(settings)) { hfree settings }
  if ($hget(lookup)) { hfree lookup }
  if ($hget(varhashes)) { hfree varhashes }
  if ($1 == all) {
    if ($hget(global_settings)) { hfree global_settings }
  }
}

;returns status of info collection (getting vars etc)
alias -l getstatus {
  var %percentdone = $round($calc(($3 / $2) * 100),2), %display = $iif($1 == collect,Collecting information...,Writing script...)
  if ($dialog(MSO)) { showinfo <SL> %display $+(%percentdone,$chr(37)) }
  else {
    var %quarter = $floor($calc($2 / 4))
    if ($3 == %quarter) { showinfo <SL> %display 25%  }
    elseif ($3 == $calc(%quarter * 2)) { showinfo <SL> %display 50% }
    elseif ($3 == $calc(%quarter * 3)) { showinfo <SL> %display 75% }
    elseif ($3 == $calc(%quarter * 4)) { showinfo <SL> %display 100% | var %percentdone = 100 }
  }
}

;displays information (<SL> for same line if in dialog)
alias -l showinfo {
  if ($dialog(MSO)) {
    if ($1 == <SL>) { did -o $dname 15 $did($dname,15).lines $2- }
    elseif ($1 == <DL>) { did -a $dname 15 | did -a $dname 15 $2- | did -c $dname 15 $did($dname,15).lines | did -u $dname 15 $did($dname,15).lines }
    else { did -a $dname 15 $1- | did -c $dname 15 $did($dname,15).lines | did -u $dname 15 $did($dname,15).lines }
  }
  else { echo -s $iif($1 == <SL> || $1 == <DL>,$2-,$1-) }
}

alias -l obfsetup {
  ;define possible regexes for the bulk of checking
  var %identifier_regex = /(?:^|[\s(,]|\(\s*!)(\$)([^\s(),]+)/
  var %binvar_regex = /(?:^|\$\(|[\s,]|\(\s*!)(&)([^\s),]+)/
  var %binvarident_regex = /(?:(?:^|[\s(,]|\(\s*!)([\$])|(?:^|\$\(|[\s,]|\(\s*!)([&]))((?(?<=&)[^,)\s]+|[^,()\s]+))/

  ;determine which one we need to accomplish all the required tasks
  if (($hget(settings,do:identifiers) == true) && ($hget(settings,do:binvars) == true)) { var %regex = %binvarident_regex }
  elseif ($hget(settings,do:identifiers) == true) { var %regex = %identifier_regex }
  else { var %regex = %binvar_regex }
  return %regex
}

;escapes text that is inserted in a regex
alias -l escapename { return $replacex($$1-,[,\[,\,\\,^,\^,$,\$,.,\.,|,\|,?,\?,*,\*,+,\+,$chr(40),\ $+ $chr(40),$chr(41),\ $+ $chr(41)) }

;scour the source for aliases/variables/identifiers
alias varsearch {
  var %regex = $1, %followon = $iif($2 == true,$v2,$null), %line = $hget(settings,temp:line)

  ;aliases (alias lines)
  if ($gettok($hget(settings,do:aliases),1,32) == true) { 
    var %type = $gettok($hget(settings,do:aliases),2,32), %alias_regex = /^alias\s+(-l\s+)([^\s(),]+)/, %alias_regex_global = /^alias\s+(-l\s+)?([^\s(),]+)/, %follow_regex = /\$&\s*$/
    if ($regex(%line,%follow_regex)) { var %follow = true }
    if (($regex(%line,$iif(%type == global,%alias_regex_global,%alias_regex))) && ($regml(1))) { 
      if (($left($regml(1),2) == -l) && ($regml(2))) { var %alias = $regml(2), %vartype = local }
      elseif ($left($regml(1),2) != -l) { var %alias = $regml(1), %vartype = global }
      if (%alias) { hadd -m lookup $+(alias:,%alias) %vartype %alias }
    }
  }
  ;variable declaration (var/set -l lines)
  if ($hget(settings,do:variables) == true) { 
    var %linetemp = %line, %varfind_regex = /var\s+%[^\s),]+/, %varfind_alternative_regex = /set\s+-l\s+%([^\s),]+)/, %identifier_strip_regex = /\$\S*\((((?>[^()]+)|(?R))*)\)/
    var %variable_local_regex = /(?:var\s+|,\s*)%([^\s),]+)/, %variable_follow_regex = /(?:var\s+|,\s*|^\s*)%([^\s),]+)/
    ;search for var lines
    if ($regex(%line,%varfind_regex)) || (%followon) {
      ;get rid of as many identifiers as we can - they can screw things up
      var %x = $regsub(%linetemp,%identifier_strip_regex,$null,%linetemp)
      ;hunt through remaining line finding vars and getting rid of as much non-var code as possible to ease further parsing
      while ($regsub(%linetemp,$iif(%followon,%variable_follow_regex,%variable_local_regex),$null,%linetemp)) { 
        if (!$hget(lookup,$+(variable:,$regml(1)))) { hadd -m lookup $+(variable:,$regml(1)) local $regml(1) }
      }
    }
    ;search for set -l lines
    if ($regex(%line,%varfind_alternative_regex)) {
      ;loop through any adding them (should only put one but can never assume good scripting) 
      while ($regsub(%linetemp,%varfind_alternative_regex,$null,%linetemp)) { 
        if (!$hget(lookup,$+(variable:,$regml(1)))) { hadd -m lookup $+(variable:,$regml(1)) local $regml(1) }
      }
    }
  }
  ;vars/binvars/identifiers
  if ($hget(settings,do:variables) == true) || ($hget(settings,do:identifiers) == true) || ($hget(settings,do:binvars) == true) { 
    while ($regsub(%line,%regex,$null,%line)) { 

      ;check for null and get rid of crap like $1 $1-2 $? $& $!
      if (($regml(1) == $chr(36)) && ((!$regml(2)) || ($regml(2) isin +&!?*) || (mircdir* iswm $regml(2)) || (scriptdir* iswm $regml(2)) || ($left($remove($regml(2),$chr(36)),1) isnum))) || ($findtok(iif prop isid,$regml(2),32)) { continue }  
      elseif (($regml(1) == $chr(37)) && (!$regml(2))) { continue }
      elseif (($regml(1) == $chr(38)) && ((!$regml(2)) || ($regml(2) == $chr(38)))) { continue }

      ;check if identifier has already been tagged by the alias script - if so don't retag it
      elseif (($regml(1) == $chr(36)) && ($hget(lookup,$+(alias:,$remove($regml(2),$chr(36)))))) { continue }
      ;check symbol to determine type and add appropriately
      if ($regml(1) == $chr(36)) { hadd -m lookup $+(identifier:,$regml(2)) $regml(2) }
      elseif (($regml(1) == $chr(37)) && (!$hget(lookup,$+(variable:,$regml(2))))) { hadd -m lookup $+(variable:,$regml(2)) global $regml(2) }
      elseif ($regml(1) == $chr(38)) { hadd -m lookup $+(binvar:,$regml(2)) $regml(2) }
    }
  }
  ;we have $& so make sure we're told that (for multi lined var declarations)
  if (%follow) { return followon }
}

;generate a lookup table of obfuscated names using the hash tables generated by varsearch
alias genlookup {
  hmake varhashes 100
  var %i = 1
  while ($hget(lookup,%i).item) { 
    dll " $+ $scriptdir $+ WhileFix.dll" WhileFix 
    var %item = $ifmatch, %hash = $makehash($iif($findtok(alias variable identifier,$gettok(%item,1,58),1,32),alias)) 
    hadd lookup %item $iif($numtok($hget(lookup,%item),32) > 1,$gettok($hget(lookup,%item),1,32),$null) %hash 
    hadd varhashes %hash true 
    inc %i 
  }
}

;read in the original script and write it back out with replacements from the lookup table made
alias writescript {
  var %script = $$1-, %outdir = $hget(settings,out:dir), %outfile = $hget(settings,out:file), %lines = $lines(%script), %done = 1
  if (!$exists(%outdir)) { mkdir %outdir }
  write -c %outfile

  while (%done <= %lines) {
    dll " $+ $scriptdir $+ WhileFix.dll" WhileFix 
    if ($hget(global_settings,status:stop) == true) || (!$dialog(MSO)) { 
      showinfo <DL> Obfuscation aborted... 
      freetables all
      if ($dialog(MSO)) { did -e $dname 6,8,9,10,11,18,31 }
      halt 
    }
    getstatus write %lines %done
    var %line = $read(%script,n,%done), %i = 1
    if (!%line) || ($left(%line,1) == $chr(59)) || ($left(%line,2) == /*) { 
      if ((%line) && ($hget(settings,do:comments) != true)) { echo heh:: %file write %file %line }
      inc %done | continue
    }
    while ($hget(lookup,%i).item) {
      var %item = $ifmatch, %x = $regex(%item,/^(\w+):(\S*)/), %type = $regml(1), %name = $regml(2)
      if (%type == alias) || (%type == variable) { var %replacement = $gettok($hget(lookup,%item),2,32) }
      else { var %replacement = $hget(lookup,%item) }

      ;aliases
      if ((%type == alias) && ($gettok($hget(settings,do:aliases),1,32) == true)) {                                                       
        var %find_alias_normal =  /(^\s*/?|alias\s+(?:-l\s+)?/?|alias\s+(?:-l\s+)?(?:\S+)?\s+/?|timer.*?\s+(?:-\S*\s+)?(\d+:\d+\s+)?\d+\s+\d+\s+(\S+)|{\s+|\/?|\s+/?|(?:(?:else)?if|while)\s+\(.*\)\s+/?|^\s*else\s+(?:\{\s+)?/?|^on\s.:\S+:\s*/?) $+ $escapename(%name) $+ (?=\s|$)/, %find_alias_identifier = /\$\$? $+ $escapename(%name) $+ (?=[\s,()]|$)/      
        while ($regsub(%line,%find_alias_normal,$+(\1,%replacement),%line)) { noop }               
        while ($regsub(%line,%find_alias_identifier,$+($,%replacement),%line)) { noop }   
      }
      ;variables
      elseif ((%type == variable) && ($hget(settings,do:variables) == true)) { 
        var %find_vars_regex = /([\s^]|,\s*|\$[^\s(,]*?\(|(?:else)?if\s+\((?:\s*!)?|while\s+\((?:\s*!)?)% $+ $escapename(%name) $+ (?=[\s,)]|$)/
        while ($regsub(%line,%find_vars_regex,$+(\1,$chr(37),%replacement),%line)) { noop }
      }
      ;binary variables
      elseif ((%type == binvar) && ($hget(settings,do:binvars) == true)) { 
        var %find_binvars_regex = /& $+ $escapename(%name) $+ (?=[\s),]|$)/
        while ($regsub(%line,%find_binvars_regex,$+(&,%replacement),%line)) { noop }
      }
      ;identifiers
      elseif ((%type == identifier) && ($hget(settings,do:identifiers) == true) && (!$gettok($hget(lookup,$+(alias:,%name)),1,32))) {
        var %find_identifiers_regex = /\$\$? $+ $escapename(%name) $+ (?=[\s(),]|$)/
        while ($regsub(%line,%find_identifiers_regex,$+($,%replacement),%line)) { noop }
      }
      inc %i
    }
    write %outfile %line
    inc %done
  }
  if ($hget(settings,do:identifiers) == true) {
    var %identifiers = $hfind(lookup,identifier:*,0,w)
    while (%identifiers) {
      var %identifier_name = $hfind(lookup,identifier:*,%identifiers,w)
      if ($findtok(v1 v2 ifmatch,$remove($gettok(%identifier_name,2,58),$chr(36)),32)) { write %outfile alias -l $hget(lookup,%identifier_name) return $+($,$gettok(%identifier_name,2,58)) }
      write %outfile alias -l $hget(lookup,%identifier_name) var $+(%,i) 0 $+ , $+ $+(%,l) $chr(124) while (%i < $ $+ 0) $chr(123) inc $+(%,i) $chr(124) $+(%,l) = $+(%,l) $+($,+) , $+ $ $+($,+) $+(%,i) $chr(125) $chr(124) return $ $+ iif(%l $chr(124) $+ $chr(124) $+($,prop) $+ , $+ $ $+ ( $+ $ $+($,+) $gettok(%identifier_name,2,58) $+ ( $ $+ mid(%l,2) ) $+($,+) $ $+ iif($prop $+ , $+ $+($,+) $+ (.,$v1)) $+ ,2), $+ $ $+ $gettok(%identifier_name,2,58)$+ )       
      dec %identifiers
    }
  }
  return
}

;generates an obfuscated name for an alias/variable/identifier/binvar
alias makehash {
  var %charset = $hget(global_settings,hash:charset), %min = $hget(global_settings,hash:min_length), %max = $hget(global_settings,hash:max_length), %length = $rand(%min,%max), %hash
  if (!%charset) { var %charset = O0 }
  if (!%min) { var %min = 8 }
  if (!%max) { var %max = 10 }
  while (!%hash) || ($hget(varhashes,%hash)) || ($hget(lookup,$+($1,:,%hash))) { 
    var %hash
    if (($1 == alias) && (!%hash)) {
      if (%charset isnum) { var %hash = O } 
      while ((!%hash) || (!%x) || (%x isnum)) { var %x = $mid(%charset,$rand(1,$len(%charset)),1) | var %hash = %x } 
    }
    while ($len(%hash) < %length) { var %hash = %hash $+ $mid(%charset,$rand(1,$len(%charset)),1) }  
  }
  return %hash
}
